#$say Levels : $(Levels)
#$say Levels : $(primary_effect)
#$say Levels : $(secondary_effect)


## Setting the beacon values into a combined storage with range etc.



$data modify storage minecraft:beaconstorage input.Levels set value "$(Levels)"
$data modify storage minecraft:beaconstorage input.primary_effect set value "$(primary_effect)"
execute as @s at @s if data block ~ ~-1 ~ secondary_effect run data modify storage minecraft:beaconstorage input.secondary_effect set from block ~ ~-1 ~ secondary_effect

## Setting the level of the beacon to the sore of the beacon
$scoreboard players set @s k_bb_beacon_lvl $(Levels)

## save upgrades into storage
execute as @s store result storage minecraft:beaconstorage input.ups int 1 run scoreboard players get @s kbb_upgraded

## caclulating range
scoreboard objectives add kbb_calc_temp1 dummy
scoreboard objectives add kbb_calc_temp2 dummy
scoreboard objectives add kbb_calc_temp3 dummy
scoreboard objectives add kbb_calc_temp4 dummy

scoreboard players operation @s kbb_calc_temp1 = @s kbb_calc
scoreboard players operation @s kbb_calc_temp1 += range1 kbb_variables

scoreboard players operation @s kbb_calc_temp2 = @s kbb_calc
scoreboard players operation @s kbb_calc_temp2 += range2 kbb_variables

scoreboard players operation @s kbb_calc_temp3 = @s kbb_calc
scoreboard players operation @s kbb_calc_temp3 += range3 kbb_variables

scoreboard players operation @s kbb_calc_temp4 = @s kbb_calc
scoreboard players operation @s kbb_calc_temp4 += range4 kbb_variables

## add the caclulated range to the storage
execute store result storage minecraft:beaconstorage input.r1 int 1 run scoreboard players get @s kbb_calc_temp1
execute store result storage minecraft:beaconstorage input.r2 int 1 run scoreboard players get @s kbb_calc_temp2
execute store result storage minecraft:beaconstorage input.r3 int 1 run scoreboard players get @s kbb_calc_temp3
execute store result storage minecraft:beaconstorage input.r4 int 1 run scoreboard players get @s kbb_calc_temp4

## remove scorebaods
scoreboard objectives remove kbb_calc_temp1
scoreboard objectives remove kbb_calc_temp2
scoreboard objectives remove kbb_calc_temp3
scoreboard objectives remove kbb_calc_temp4

## set Effect lvl text
execute if block ~ ~-0.5 ~ beacon{Levels:1} run data modify storage minecraft:beaconstorage input.max_e_ups set value 1
execute if block ~ ~-0.5 ~ beacon{Levels:2} run data modify storage minecraft:beaconstorage input.max_e_ups set value 2
execute if block ~ ~-0.5 ~ beacon{Levels:3} run data modify storage minecraft:beaconstorage input.max_e_ups set value 3
execute if block ~ ~-0.5 ~ beacon{Levels:4} run data modify storage minecraft:beaconstorage input.max_e_ups set value 4

## get e ups of the entity
execute as @s store result storage minecraft:beaconstorage input.e_ups int 1 run scoreboard players get @s kbb_e_upgraded
# max 3 on regen and resis
scoreboard objectives add kbb_calc_invin_e_ups dummy
scoreboard players operation @s kbb_calc_invin_e_ups = @s kbb_e_upgraded
execute if score o_effinv kbb_options matches 0 if score @s kbb_e_upgraded matches 4 run scoreboard players set @s kbb_calc_invin_e_ups 3
execute as @s store result storage minecraft:beaconstorage input.max_rr_e_ups int 1 run scoreboard players get @s kbb_calc_invin_e_ups
execute if score o_effinv kbb_options matches 1 if score @s kbb_e_upgraded matches 4 run scoreboard players set @s kbb_calc_invin_e_ups 5
execute as @s store result storage minecraft:beaconstorage input.max_rr_e_ups2 int 1 run scoreboard players get @s kbb_calc_invin_e_ups
scoreboard objectives remove kbb_calc_invin_e_ups


## e ups +1 for lvl 4 beacons
scoreboard objectives add kbb_eeu_temp dummy
scoreboard players set @s kbb_eeu_temp 1
scoreboard players operation @s kbb_eeu_temp += @s kbb_e_upgraded
execute as @s store result storage minecraft:beaconstorage input.e_ups2 int 1 run scoreboard players get @s kbb_eeu_temp
scoreboard objectives remove kbb_eeu_temp

## strikethoughs
# range ups
execute if score r_ups kbb_options matches 1 run data modify storage minecraft:beaconstorage input.st_rup set value "false"
execute if score r_ups kbb_options matches 0 run data modify storage minecraft:beaconstorage input.st_rup set value "true"
# effect ups
execute if score e_ups kbb_options matches 1 run data modify storage minecraft:beaconstorage input.st_eup set value "false"
execute if score e_ups kbb_options matches 0 run data modify storage minecraft:beaconstorage input.st_eup set value "true"

#execute as @s at @s run function k_bb:beacon/func/test with storage minecraft:beaconstorage input